import org.xml.sax.*;
import java.io.*;
import org.apache.xerces.parsers.*;

public class SchemaValidate {
   
   public static void main(String[] args){

      if (args.length !=1) {System.out.println("Specify XML document!"); System.exit(1);}
      String uri = args[0];
      XMLReader reader = new SAXParser();
      ErrorHandler errr = new My2ErrorHandler();

      try 
      {
         reader.setErrorHandler(errr);
         reader.setFeature("http://xml.org/sax/features/validation", true );
         reader.setFeature("http://apache.org/xml/features/validation/schema", true); 
         reader.setFeature("http://apache.org/xml/features/validation/schema-full-checking", true);
         
         reader.parse(uri);
         System.out.println("Finished Parsing.");
      }
      catch (IOException e) {System.out.println("Error while reading " + args[0] +": " + e.getMessage());}
      catch (SAXException e) {System.out.println("Error while parsing " + args[0] + ": " + e.getMessage());}
   }
}

class My2ErrorHandler implements ErrorHandler{


   public void warning(SAXParseException e) throws SAXException 
   {
      System.out.println("WARNING: " + e);
   }

   public void error(SAXParseException e) throws SAXException 
   {
     System.out.println("ERROR: " + e);
   }

   public void fatalError(SAXParseException e) throws SAXException
   {
     System.out.println("FATAL ERROR: " + e);
   }


}
